/****************************************************************************
 ** ScStw Libraries
 ** Copyright (C) 2020  Itsblue development
 **
 ** This program is free software: you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation, either version 3 of the License, or
 ** (at your option) any later version.
 **
 ** This program is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 **
 ** You should have received a copy of the GNU General Public License
 ** along with this program.  If not, see <http://www.gnu.org/licenses/>.
 ****************************************************************************/

#ifndef SCSTWREMOTEMONITORRACE_H
#define SCSTWREMOTEMONITORRACE_H

#include <QObject>
#include "scstwrace.h"
#include "scstwclient.h"

class ScStwRemoteMonitorRace : public ScStwRace
{
    Q_OBJECT
public:
    ScStwRemoteMonitorRace(ScStwClient *monitorClient, QObject *parent = nullptr);

protected:
    double nextStartActionTotalDelay;
    double nextStartActionDelayStartedAt;

private:
    ScStwClient *scStwClient;

public slots:
    int start();
    int cancel();
    int stop();
    int reset();
    bool addTimer(ScStwTimer *timer);
    QVariantList getNextStartActionDetails();

private slots:
    void handleClientStateChanged();
    void handleBaseStationSignal(ScStw::SignalKey key, QVariant data);
    bool refreshRemoteTimers(QVariantList remoteTimers);

};

#endif // SCSTWREMOTEMONITORRACE_H
